unit MainAppUnit;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
	Dialogs, ExtCtrls, ComCtrls, BPLBase, BPLServer, Menus, ImgList;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    exit1: TMenuItem;
    ModulesMenu: TMenuItem;
    Configure1: TMenuItem;
    DynBPLServer: TDynBPLServer;
    Panel1: TPanel;
		N1: TMenuItem;
		FormsMenu: TMenuItem;
		NoFormMenu: TMenuItem;
    ImageList1: TImageList;
		Test1: TMenuItem;
		Reportnumberoficons1: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure exit1Click(Sender: TObject);
		procedure Configure1Click(Sender: TObject);
		procedure DynBPLServerServiceCall(Sender: TObject; ServiceText: String;
			ServiceNumber: Integer; Subject: TObject; out handled: Boolean);
		procedure FormMenuClick(Sender: TObject);
		procedure Reportnumberoficons1Click(Sender: TObject);
	private
		{ Private-Deklarationen }
		procedure AddForm(Client: TDynBPLBase; ClientForm: TForm);
	public
		{ Public-Deklarationen }
		procedure Notification(AComponent: TComponent; Operation: TOperation); override;
	end;

var
	MainForm: TMainForm;

implementation

uses ClassUnit;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
	DynBPLServer.IniFileName :=
		ChangeFileExt( Application.ExeName, '.ini' );
	DynBPLServer.LoadFromIniFile;
	DynBPLServer.CallService('App.Start',nil,true);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
	i: integer;
begin
	for i:=0 to FormsMenu.Count -1 do
	begin
		if FormsMenu.Items[i].Tag <> 0 then
		begin
			TForm( FormsMenu.Items[i].Tag ).Visible := false;
			TForm( FormsMenu.Items[i].Tag ).Parent := nil;
		end;
	end;

	DynBPLServer.CallService('App.End',nil,true);
end;

procedure TMainForm.exit1Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.Configure1Click(Sender: TObject);
begin
	DynBPLServer.ConfigDialog;
	DynBPLServer.SaveToIniFile;
end;

procedure TMainForm.DynBPLServerServiceCall(Sender: TObject;
	ServiceText: String; ServiceNumber: Integer; Subject: TObject;
	out handled: Boolean);
var
	menu: TPopupMenu;
begin
	case ServiceNumber of
		0:  // Add.Form
				if Subject is TForm then
					AddForm( (Sender as TDynBPLBase), (Subject as TForm) );
		1:  // Add.Menu
				if Subject is TPopupMenu then
				begin
					menu := (Subject as TPopupMenu);
					ModulesMenu.Add(menu.Items);
					menu.Items.Caption := (Sender as TDynBPLBase).Caption;
				end;
		2:  // Say.*
					ShowMessage( PChar(ServiceText)+4 );

	end;
end;

procedure TMainForm.AddForm(Client: TDynBPLBase; ClientForm: TForm);
var
	mItem: TMenuItem;
begin
	ClientForm.Parent := Panel1;
	ClientForm.Visible := false;
	ClientForm.Align := alClient;
	ClientForm.BorderStyle := bsNone;
	ClientForm.BorderIcons := [];
	ClientForm.TabStop := true;
	ClientForm.TabOrder := 0;
	FreeNotification(ClientForm);

	mItem := TMenuItem.Create(Client);
	mItem.Caption := ClientForm.Caption;
	mItem.tag := integer(ClientForm);
	mItem.OnClick := FormMenuClick;

	if not ClientForm.Icon.Empty then
		mItem.ImageIndex := ImageList1.AddIcon(ClientForm.Icon);

	FormsMenu.Add(mItem);
end;

procedure TMainForm.FormMenuClick(Sender: TObject);
var
	i: integer;
	mItem: TMenuItem;
begin
	mItem := Sender as TMenuItem;
	if mItem.Checked then
		exit;

	for i:=0 to FormsMenu.Count -1 do
	begin
		FormsMenu.Items[i].Checked := false;
		if FormsMenu.Items[i].Tag <> 0 then
			TForm( FormsMenu.Items[i].Tag ).Visible := false;
	end;

	mItem.Checked := true;
	if mItem.Tag = 0 then
		exit;
	TForm( mItem.Tag ).Visible := true;
end;

procedure TMainForm.Reportnumberoficons1Click(Sender: TObject);
begin
	ShowMessage( Inttostr(ImageList1.Count) + ' Icons' );
end;

procedure TMainForm.Notification(AComponent: TComponent;
	Operation: TOperation);
var
	i: integer;
	mItem: TMenuItem;
begin
	inherited Notification(AComponent, Operation);

	if(AComponent = self)
	or(AComponent.Owner = self)
	or(Operation <> opRemove)
	or(csDestroying	in ComponentState) then
		exit;

	for i:=0 to FormsMenu.Count -1 do
	begin
		mItem := FormsMenu.Items[i];
		if mItem.Tag = integer(AComponent) then
		begin
			if mItem.ImageIndex >= 0 then
				ImageList1.Delete(mItem.ImageIndex);
			mItem.ImageIndex := -1;
		end;
	end;

end;

end.
